
public class Parse {

	/**
	 * @param args
	 */
	public static Pair main(String s, int i) {
		//Parses the string s to (tree,endIndex) from startIndex i
		if ( i < s.length() - 1 ) {
			if ( s.charAt(i) == '(' 
				&& '0' <= s.charAt(i+1) 
				&& s.charAt(i+1) <= '9') {
					int j = i+1;
					while (j < s.length() 
							&& '0' <= s.charAt(j) 
							&& s.charAt(j) <= '9') {
								j++;
					}
					//System.out.print("i = " + i + "; j=" + j);
					Pair res = new Pair(null,j+1);
					res.tree = new Leaf(Integer.parseInt(s.substring(i+1,j),10));
					return res;
			}
			else {
				if ( s.charAt(i+1) == ')' ) {
					Pair res = new Pair(null, i+2);
					return res;					
				} else {
					Pair p1 = Parse.main(s, i+1);
					Pair p2 = Parse.main(s, p1.ind);
					Node res = new Node();
					res.left = p1.tree;
					res.right = p2.tree;
					Pair pres = new Pair(res,p2.ind+1);
					return pres;
				}
			}
		}
		else {
			Pair res = new Pair(null,s.length());
			return res;
		}
	}

}
